std::reverse_iterator< _Iterator > Class Template Reference
Iterators

`#include <stl_iterator.h>`

Inheritance diagram for std::reverse_iterator< _Iterator >:
[legend]

## Public Types

typedef __traits_type::difference_type | difference_type
typedef iterator_traits< _Iterator >::iterator_category | iterator_category
typedef _Iterator | iterator_type
typedef __traits_type::pointer | pointer
typedef __traits_type::reference | reference
typedef iterator_traits< _Iterator >::value_type | value_type

## Public Member Functions

constexpr | reverse_iterator ()
constexpr | reverse_iterator (const reverse_iterator &__x)
template<typename _Iter >
constexpr | reverse_iterator (const reverse_iterator< _Iter > &__x)
constexpr | reverse_iterator (iterator_type __x)
constexpr iterator_type | base () const
constexpr reference | operator* () const
constexpr reverse_iterator | operator+ (difference_type __n) const
constexpr reverse_iterator & | operator++ ()
constexpr reverse_iterator | operator++ (int)
constexpr reverse_iterator & | operator+= (difference_type __n)
constexpr reverse_iterator | operator- (difference_type __n) const
constexpr reverse_iterator & | operator-- ()
constexpr reverse_iterator | operator-- (int)
constexpr reverse_iterator & | operator-= (difference_type __n)
constexpr pointer | operator-> () const
reverse_iterator & | operator= (const reverse_iterator &)=default
template<typename _Iter >
constexpr reverse_iterator & | operator= (const reverse_iterator< _Iter > &__x)
constexpr reference | operator[] (difference_type __n) const

## Protected Types

typedef iterator_traits< _Iterator > | __traits_type

## Protected Attributes

_Iterator | current

## Detailed Description

template<typename _Iterator>
class std::reverse_iterator< _Iterator >

Bidirectional and random access iterators have corresponding reverse iterator adaptors that iterate through the data structure in the opposite direction. They have the same signatures as the corresponding iterators. The fundamental relation between a reverse iterator and its corresponding iterator `i` is established by the identity:

&*(reverse_iterator(i)) == &*(i - 1)
std::reverse_iterator
Definition bits/stl_iterator.h:134
std::auto_ptr_ref
Definition auto_ptr.h:49

This mapping is dictated by the fact that while there is always a pointer past the end of an array, there might not be a valid pointer before the beginning of an array. [24.4.1]/1,2

Reverse iterators can be tricky and surprising at first. Their semantics make sense, however, and the trickiness is a side effect of the requirement that the iterators must be safe.

Definition at line 128 of file bits/stl_iterator.h.

## Member Typedef Documentation

## __traits_type

template<typename _Iterator >

typedef iterator_traits<_Iterator> std::reverse_iterator< _Iterator >::__traits_type

protected

Definition at line 149 of file bits/stl_iterator.h.

## difference_type

template<typename _Iterator >

typedef __traits_type::difference_type std::reverse_iterator< _Iterator >::difference_type

Definition at line 155 of file bits/stl_iterator.h.

## iterator_category

typedef iterator_traits< _Iterator >::iterator_category std::iterator< iterator_traits< _Iterator >::iterator_category , iterator_traits< _Iterator >::value_type , iterator_traits< _Iterator >::difference_type , iterator_traits< _Iterator >::pointer , iterator_traits< _Iterator >::reference >::iterator_category

inherited

One of the tag types.

Definition at line 130 of file stl_iterator_base_types.h.

## iterator_type

template<typename _Iterator >

typedef _Iterator std::reverse_iterator< _Iterator >::iterator_type

Definition at line 152 of file bits/stl_iterator.h.

## pointer

template<typename _Iterator >

typedef __traits_type::pointer std::reverse_iterator< _Iterator >::pointer

Definition at line 153 of file bits/stl_iterator.h.

## reference

template<typename _Iterator >

typedef __traits_type::reference std::reverse_iterator< _Iterator >::reference

Definition at line 156 of file bits/stl_iterator.h.

## value_type

typedef iterator_traits< _Iterator >::value_type std::iterator< iterator_traits< _Iterator >::iterator_category , iterator_traits< _Iterator >::value_type , iterator_traits< _Iterator >::difference_type , iterator_traits< _Iterator >::pointer , iterator_traits< _Iterator >::reference >::value_type

inherited

The type "pointed to" by the iterator.

Definition at line 132 of file stl_iterator_base_types.h.

## Constructor & Destructor Documentation

## reverse_iterator() [1/4]

template<typename _Iterator >

constexpr std::reverse_iterator< _Iterator >::reverse_iterator | ( |  | ) |

inline constexpr

The default constructor value-initializes member `current`. If it is a pointer, that means it is zero-initialized.

Definition at line 178 of file bits/stl_iterator.h.

## reverse_iterator() [2/4]

template<typename _Iterator >

constexpr std::reverse_iterator< _Iterator >::reverse_iterator | ( | iterator_type | __x | ) |

inline explicit constexpr

This iterator will move in the opposite direction that `x` does.

Definition at line 184 of file bits/stl_iterator.h.

## reverse_iterator() [3/4]

template<typename _Iterator >

constexpr std::reverse_iterator< _Iterator >::reverse_iterator | ( | const reverse_iterator< _Iterator > & | __x | ) |

inline constexpr

The copy constructor is normal.

Definition at line 190 of file bits/stl_iterator.h.

## reverse_iterator() [4/4]

template<typename _Iterator >
template<typename _Iter >

constexpr std::reverse_iterator< _Iterator >::reverse_iterator | ( | const reverse_iterator< _Iter > & | __x | ) |

inline constexpr

A reverse_iterator across other types can be copied if the underlying iterator can be converted to the type of `current`.

Definition at line 206 of file bits/stl_iterator.h.

## Member Function Documentation

## base()

template<typename _Iterator >

constexpr iterator_type std::reverse_iterator< _Iterator >::base | ( |  | ) | const

inline constexpr

Returns
  `current`, the iterator used for underlying work.

Definition at line 228 of file bits/stl_iterator.h.

## operator*()

template<typename _Iterator >

constexpr reference std::reverse_iterator< _Iterator >::operator* | ( |  | ) | const

inline constexpr

Returns
  A reference to the value at `--current`

This requires that `--current` is dereferenceable.

Warning
  This implementation requires that for an iterator of the underlying iterator type, `x`, a reference obtained by `*x` remains valid after `x` has been modified or destroyed. This is a bug: http://gcc.gnu.org/PR51823

Definition at line 242 of file bits/stl_iterator.h.

## operator+()

template<typename _Iterator >

constexpr reverse_iterator std::reverse_iterator< _Iterator >::operator+ | ( | difference_type | __n | ) | const

inline constexpr

Returns
  A reverse_iterator that refers to `current` - __n

The underlying iterator must be a Random Access Iterator.

Definition at line 323 of file bits/stl_iterator.h.

## operator++() [1/2]

template<typename _Iterator >

constexpr reverse_iterator & std::reverse_iterator< _Iterator >::operator++ | ( |  | ) |

inline constexpr

Returns
  `*this`

Decrements the underlying iterator.

Definition at line 273 of file bits/stl_iterator.h.

## operator++() [2/2]

template<typename _Iterator >

constexpr reverse_iterator std::reverse_iterator< _Iterator >::operator++ | ( | int |  | ) |

inline constexpr

Returns
  The original value of `*this`

Decrements the underlying iterator.

Definition at line 285 of file bits/stl_iterator.h.

## operator+=()

template<typename _Iterator >

constexpr reverse_iterator & std::reverse_iterator< _Iterator >::operator+= | ( | difference_type | __n | ) |

inline constexpr

Returns
  *this

Moves the underlying iterator backwards __n steps. The underlying iterator must be a Random Access Iterator.

Definition at line 333 of file bits/stl_iterator.h.

## operator-()

template<typename _Iterator >

constexpr reverse_iterator std::reverse_iterator< _Iterator >::operator- | ( | difference_type | __n | ) | const

inline constexpr

Returns
  A reverse_iterator that refers to `current` - __n

The underlying iterator must be a Random Access Iterator.

Definition at line 345 of file bits/stl_iterator.h.

## operator--() [1/2]

template<typename _Iterator >

constexpr reverse_iterator & std::reverse_iterator< _Iterator >::operator-- | ( |  | ) |

inline constexpr

Returns
  `*this`

Increments the underlying iterator.

Definition at line 298 of file bits/stl_iterator.h.

## operator--() [2/2]

template<typename _Iterator >

constexpr reverse_iterator std::reverse_iterator< _Iterator >::operator-- | ( | int |  | ) |

inline constexpr

Returns
  A reverse_iterator with the previous value of `*this`

Increments the underlying iterator.

Definition at line 310 of file bits/stl_iterator.h.

## operator-=()

template<typename _Iterator >

constexpr reverse_iterator & std::reverse_iterator< _Iterator >::operator-= | ( | difference_type | __n | ) |

inline constexpr

Returns
  *this

Moves the underlying iterator forwards __n steps. The underlying iterator must be a Random Access Iterator.

Definition at line 355 of file bits/stl_iterator.h.

## operator->()

template<typename _Iterator >

constexpr pointer std::reverse_iterator< _Iterator >::operator-> | ( |  | ) | const

inline constexpr

Returns
  A pointer to the value at `--current`

This requires that `--current` is dereferenceable.

Definition at line 254 of file bits/stl_iterator.h.

## operator=()

template<typename _Iterator >
template<typename _Iter >

constexpr reverse_iterator & std::reverse_iterator< _Iterator >::operator= | ( | const reverse_iterator< _Iter > & | __x | ) |

inline constexpr

Definition at line 217 of file bits/stl_iterator.h.

## operator[]()

template<typename _Iterator >

constexpr reference std::reverse_iterator< _Iterator >::operator[] | ( | difference_type | __n | ) | const

inline constexpr

Returns
  The value at `current` - __n - 1

The underlying iterator must be a Random Access Iterator.

Definition at line 367 of file bits/stl_iterator.h.

## Friends And Related Symbol Documentation

## reverse_iterator

template<typename _Iterator >
template<typename _Iter >

friend class reverse_iterator

friend

Definition at line 136 of file bits/stl_iterator.h.

## Member Data Documentation

## current

template<typename _Iterator >

_Iterator std::reverse_iterator< _Iterator >::current

protected

Definition at line 147 of file bits/stl_iterator.h.

The documentation for this class was generated from the following file:

- bits/stl_iterator.h